from iotv import doutbit,aout,din,ain

def set_color(color,id):
    if color == "Red":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],0)
    elif color == "Green":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],0)
    elif color == "Blue":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],1)
    elif color == "":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],0)
    elif color == "White":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],1)
    elif color == "Yellow":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],0)
    elif color == "Magenta":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],1)
    elif color == "Cyan":
        doutbit(id["dvertAddr"],id["side"],id["RedPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["GreenPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["BluePin"],1)

def set_color_temperature_door(color,id):
    if color == "Cold White":
        doutbit(id["dvertAddr"],id["side"],id["coldPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["warmPin"],1)
    elif color == "Warm White":
        doutbit(id["dvertAddr"],id["side"],id["coldPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["warmPin"],0)
    elif color == "White":
        doutbit(id["dvertAddr"],id["side"],id["coldPin"],1)
        doutbit(id["dvertAddr"],id["side"],id["warmPin"],1)
    elif color == "":
        doutbit(id["dvertAddr"],id["side"],id["coldPin"],0)
        doutbit(id["dvertAddr"],id["side"],id["warmPin"],0)

def v2aout(voltage0_10):
    retV = round((voltage0_10*4095)/10)
    if retV < 0:
        retV = 0
    if retV > 4095:
        retV = 4095
    return retV

def set_brightness(level,id):
    if level < 0:
        level = 0
    if level > 10:
        level = 10
    aout(id["avertAddr"],id["side"],id["brightnessChannel"],v2aout(level))

def set_color_temperature_cabin(level,id):
    # 0: Warm White, 10: Cold White
    if level < 0:
        level = 0
    if level > 10:
        level = 10
    aout(id["avertAddr"],id["side"],id["temperatureChannel"],v2aout(level))

def bin_to_dec(s):
    return int(s, 2)
    
def read_selectors(id):
    # 0: Middle, 1: Right, 2: Left
    inV = din(id["dvertAddr"],id["side"])
    return (1 if inV[7-int(id["pin1"])] == '1' else 0) + (2 if inV[7-int(id["pin2"])] == '1' else 0)
    # return bin_to_dec(din(id["dvertAddr"],id["side"]))

def ain2v(ainValue):
    return round((((20*ainValue)/26624)-10)*100)/100

def read_potentiometer(pos,id):
    # pos: 1, 2, 3, 4 
    return (ain2v(ain(id["avertAddr"],id["side"],pos)))
    
def digitalOutput(bValue,id):
    # bValue = True or False
    doutbit(id["dvertAddr"],id["side"],id["pin"],bValue)
